package sep

import (
	"context"
	"encoding/json"
	"net/http"

	"repository.basistech.ru/BASIS/dynamix-golang-sdk/v14/internal/validators"
)

// ConfigFieldEditRequest struct to edit config fields
type ConfigFieldEditRequest struct {
	// Storage endpoint provider ID
	// Required: true
	SEPID uint64 `url:"sep_id" json:"sep_id" validate:"required"`

	// Field name
	// Required: true
	FieldName string `url:"field_name" json:"field_name" validate:"required"`

	// Field value
	// Required: true
	FieldValue string `url:"field_value" json:"field_value" validate:"required"`

	// Field type
	// Should be one of:
	//	- int
	//	- str
	//	- bool
	//	- list
	//	- dict
	// Required: true
	FieldType string `url:"field_type" json:"field_type" validate:"sepFieldType"`
}

// ConfigFieldEdit edits SEP config field value
func (s SEP) ConfigFieldEdit(ctx context.Context, req ConfigFieldEditRequest) (*RecordConfigFieldEdit, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return nil, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/sep/configFieldEdit"

	res, err := s.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return nil, err
	}

	info := RecordConfigFieldEdit{}

	err = json.Unmarshal(res, &info)
	if err != nil {
		return nil, err
	}

	return &info, nil
}
